toolchain/musl: remove old CONFIG_MUSL_ENABLE_DEBUG option
[openwrt/staging/yousong.git] / toolchain / Config.in
index 1d7f1ab..1eb99e3 100644 (file)
+# Copyright (C) 2006-2013 OpenWrt.org
 #
-config NATIVE_TOOLCHAIN
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+menuconfig TARGET_OPTIONS
+       bool "Target Options"  if DEVEL
+
+       config TARGET_OPTIMIZATION
+               string "Target Optimizations" if TARGET_OPTIONS
+               default DEFAULT_TARGET_OPTIMIZATION
+               help
+                 Optimizations to use when building for the target host.
+
+       config SOFT_FLOAT
+               bool "Use software floating point by default" if TARGET_OPTIONS
+               default y if !HAS_FPU
+               depends on arm || armeb || powerpc || mipsel || mips || mips64el || mips64
+               help
+                 If your target CPU does not have a Floating Point Unit (FPU) or a
+                 kernel FPU emulator, but you still wish to support floating point
+                 functions, then everything will need to be compiled with soft floating
+                 point support (-msoft-float).
+
+                 Most people will answer N.
+
+       config USE_MIPS16
+               bool "Build packages with MIPS16 instructions" if TARGET_OPTIONS
+               depends on HAS_MIPS16
+               default y
+               help
+                 If your target CPU does support the MIPS16 instruction set
+                 and you want to use it for packages, enable this option.
+                 MIPS16 produces smaller binaries thus reducing pressure on
+                 caches and TLB.
+
+                 Most people will answer N.
+
+
+menuconfig EXTERNAL_TOOLCHAIN
        bool
-       prompt "Use host's toolchain" if DEVEL && BROKEN
-       default n
+       prompt "Use external toolchain"  if DEVEL
        help
-               If enabled, OpenWrt will compile using your existing toolchain instead of compiling one
+         If enabled, OpenWrt will compile using an existing toolchain instead of
+         compiling one.
+
+       config NATIVE_TOOLCHAIN
+               bool
+               prompt "Use host's toolchain"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN
+               select NO_STRIP
+               help
+                 If enabled, OpenWrt will compile using the native toolchain for your
+                 host instead of compiling one.
+
+       config TARGET_NAME
+               string
+               prompt "Target name"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN
+               default "aarch64-unknown-linux-gnu"  if aarch64
+               default "aarch64_be-unknown-linux-gnu"  if aarch64_be
+               default "arm-unknown-linux-gnu"      if arm
+               default "armeb-unknown-linux-gnu"    if armeb
+               default "i486-unknown-linux-gnu"     if i386
+               default "mips-unknown-linux-gnu"     if mips
+               default "mipsel-unknown-linux-gnu"   if mipsel
+               default "powerpc-unknown-linux-gnu"  if powerpc
+               default "x86_64-unknown-linux-gnu"   if x86_64
+
+       config TOOLCHAIN_PREFIX
+               string
+               prompt "Toolchain prefix"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN
+               default "aarch64-unknown-linux-gnu"  if aarch64
+               default "aarch64_be-unknown-linux-gnu"  if aarch64_be
+               default "arm-unknown-linux-gnu-"      if arm
+               default "armeb-unknown-linux-gnu-"    if armeb
+               default "i486-unknown-linux-gnu-"     if i386
+               default "mips-unknown-linux-gnu-"     if mips
+               default "mipsel-unknown-linux-gnu-"   if mipsel
+               default "powerpc-unknown-linux-gnu-"  if powerpc
+               default "x86_64-unknown-linux-gnu-"   if x86_64
+
+       config TOOLCHAIN_ROOT
+               string
+               prompt "Toolchain root"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN
+               default "/opt/cross/aarch64-unknown-linux-gnu"  if aarch64
+               default "/opt/cross/aarch64_be-unknown-linux-gnu"  if aarch64_be
+               default "/opt/cross/arm-unknown-linux-gnu"      if arm
+               default "/opt/cross/armeb-unknown-linux-gnu"    if armeb
+               default "/opt/cross/i486-unknown-linux-gnu"     if i386
+               default "/opt/cross/mips-unknown-linux-gnu"     if mips
+               default "/opt/cross/mipsel-unknown-linux-gnu"   if mipsel
+               default "/opt/cross/powerpc-unknown-linux-gnu"  if powerpc
+               default "/opt/cross/x86_64-unknown-linux-gnu"   if x86_64
+
+       config TOOLCHAIN_LIBC
+               string
+               prompt "Toolchain libc"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN
+               default "uclibc"
+               help
+                 Specify the libc type used by the external toolchain. The given value
+                 is passed as -m flag to all gcc and g++ invocations. This is mainly
+                 intended for multilib toolchains which support glibc and uclibc at
+                 the same time. If no value is specified, no -m flag is passed.
+
+       config TOOLCHAIN_BIN_PATH
+               string
+               prompt "Toolchain program path"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN
+               default "./usr/bin ./bin"
+               help
+                 Specify additional directories searched for toolchain binaries
+                 (override PATH). Use ./DIR for directories relative to the root above.
+
+       config TOOLCHAIN_INC_PATH
+               string
+               prompt "Toolchain include path"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN
+               default "./usr/include ./include"
+               help
+                 Specify additional directories searched for header files (override
+                 CPPFLAGS). Use ./DIR for directories relative to the root above.
+
+       config TOOLCHAIN_LIB_PATH
+               string
+               prompt "Toolchain library path"  if DEVEL
+               depends on EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN
+               default "./usr/lib ./lib"
+               help
+                 Specify additional directories searched for libraries (override LDFLAGS).
+                 Use ./DIR for directories relative to the root above.
+
+config NEED_TOOLCHAIN
+       bool
+       depends on DEVEL
+       default y if !EXTERNAL_TOOLCHAIN
 
 menuconfig TOOLCHAINOPTS
-       bool "Toolchain Options" if DEVEL
-       depends !NATIVE_TOOLCHAIN
+       bool "Toolchain Options"  if DEVEL
+       depends on NEED_TOOLCHAIN
 
 menuconfig EXTRA_TARGET_ARCH
        bool
        prompt "Enable an extra toolchain target architecture" if TOOLCHAINOPTS
+       depends on !sparc
+       default y       if powerpc64
        default n
        help
          Some builds may require a 'biarch' toolchain. This option
@@ -22,6 +157,7 @@ menuconfig EXTRA_TARGET_ARCH
 
        config EXTRA_TARGET_ARCH_NAME
                string
+               default "powerpc64"     if powerpc64
                prompt "Extra architecture name" if EXTRA_TARGET_ARCH
                help
                  Specify the cpu name (eg powerpc64 or x86_64) of the
@@ -29,6 +165,7 @@ menuconfig EXTRA_TARGET_ARCH
 
        config EXTRA_TARGET_ARCH_OPTS
                string
+               default "-m64"          if powerpc64
                prompt "Extra architecture compiler options" if EXTRA_TARGET_ARCH
                help
                  If you're specifying an addition target architecture,
@@ -39,55 +176,133 @@ menuconfig EXTRA_TARGET_ARCH
                  both powerpc and powerpc64 binaries, you'll need to
                  specify -m64 here.
 
+
+       choice
+               prompt "MIPS64 user-land ABI" if TOOLCHAINOPTS && (mips64 || mips64el)
+               default MIPS64_ABI_N64
+               help
+                  MIPS64 supports 3 different user-land ABIs: o32 (legacy),
+                  n32 and n64.
+
+               config MIPS64_ABI_N64
+                       bool "n64"
+
+               config MIPS64_ABI_N32
+                       bool "n32"
+
+               config MIPS64_ABI_O32
+                       bool "o32"
+
+       endchoice
+
+comment "Binary tools"
+       depends on TOOLCHAINOPTS
+
 source "toolchain/binutils/Config.in"
+
+comment "Compiler"
+       depends on TOOLCHAINOPTS
+
 source "toolchain/gcc/Config.in"
+
+comment "C Library"
+       depends on TOOLCHAINOPTS
+
+choice
+       prompt "C Library implementation" if TOOLCHAINOPTS
+       default LIBC_USE_GLIBC if mips64 || mips64el
+       default LIBC_USE_UCLIBC if arc
+       default LIBC_USE_MUSL
+       help
+         Select the C library implementation.
+
+       config LIBC_USE_GLIBC
+               bool "Use (e)glibc"
+               select USE_GLIBC
+               depends on !arc
+
+       config LIBC_USE_UCLIBC
+               select USE_UCLIBC
+               bool "Use uClibc"
+               depends on !(aarch64 || aarch64_be)
+               depends on BROKEN || !(arm || armeb || i386 || x86_64 || mips || mipsel || mips64 || mips64el || powerpc)
+
+       config LIBC_USE_MUSL
+               select USE_MUSL
+               bool "Use musl"
+               depends on !(arc || mips64 || mips64el)
+
+endchoice
+
+source "toolchain/glibc/Config.in"
 source "toolchain/uClibc/Config.in"
 
+comment "Debuggers"
+       depends on TOOLCHAINOPTS
+
 config GDB
        bool
+       depends on !(aarch64 || aarch64_be)
        prompt "Build gdb" if TOOLCHAINOPTS
-       default n
+       default y if !EXTERNAL_TOOLCHAIN
        help
-               Enable if you want to build the gdb
+         Enable if you want to build the gdb.
 
-config LARGEFILE
+config INSIGHT
        bool
-       prompt "Enable large file (files > 2 GB) support?" if TOOLCHAINOPTS
-       default y
+       prompt "Build insight-gdb" if TOOLCHAINOPTS
+       select GDB
+       default n
        help
-               Enable large file (files > 2 GB) support
+         Enable if you want to build insight-gdb.
 
-config SHADOW_PASSWORDS
+config USE_GLIBC
        bool
-       prompt "Enable shadow password support?" if TOOLCHAINOPTS
-       default y
-       help
-               Enable shadow password support.
 
-config SOFT_FLOAT
+config USE_UCLIBC
+       default y if !TOOLCHAINOPTS && !EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN && (arc || mips64 || mips64el)
        bool
-       prompt "Use software floating point by default" if TOOLCHAINOPTS
-       default y
-       depends on arm || armeb || powerpc
-       help
-         If your target CPU does not have a Floating Point Unit (FPU) or a
-         kernel FPU emulator, but you still wish to support floating point
-         functions, then everything will need to be compiled with soft floating
-         point support (-msoft-float).
 
-         Most people will answer N.
+config USE_MUSL
+       default y if !TOOLCHAINOPTS && !EXTERNAL_TOOLCHAIN && !NATIVE_TOOLCHAIN && !(arc || mips64 || mips64el)
+       bool
 
-config TARGET_OPTIMIZATION
-       string
-       prompt "Target Optimizations" if TOOLCHAINOPTS
-       default "-O2 -pipe -march=i686 -funit-at-a-time" if TARGET_x86_mediacenter
-       default "-O2 -pipe -march=i486 -funit-at-a-time" if TARGET_x86
-       default "-Os -pipe -march=i486 -funit-at-a-time" if TARGET_rdc
-       default "-Os -pipe -mips32 -mtune=mips32 -funit-at-a-time" if mipsel || mips
-       default "-Os -pipe -march=armv5te -mtune=xscale -funit-at-a-time" if TARGET_ixp4xx || TARGET_iop32x
-       default "-Os -pipe -funit-at-a-time"
-       help
-         Optimizations to use when building for the target host.
+config USE_EXTERNAL_LIBC
+       bool
+       default y if EXTERNAL_TOOLCHAIN || NATIVE_TOOLCHAIN
 
+source "toolchain/binutils/Config.version"
 source "toolchain/gcc/Config.version"
+
+source "toolchain/glibc/Config.version"
 source "toolchain/uClibc/Config.version"
+source "toolchain/musl/Config.version"
+
+config LIBC
+       string
+       default "glibc"   if USE_GLIBC
+       default "uClibc"  if USE_UCLIBC
+       default "musl"    if USE_MUSL
+
+config LIBC_VERSION
+       string
+       default GLIBC_VERSION   if USE_GLIBC
+       default UCLIBC_VERSION  if USE_UCLIBC
+       default MUSL_VERSION    if USE_MUSL
+
+config TARGET_SUFFIX
+       string
+       default "gnueabi"         if USE_GLIBC && (arm || armeb)
+       default "gnu"             if USE_GLIBC && !(arm || armeb)
+       default "uclibcgnueabi"   if USE_UCLIBC && (arm || armeb)
+       default "uclibc"          if USE_UCLIBC && !(arm || armeb)
+       default "muslgnueabi"     if USE_MUSL && (arm || armeb)
+       default "musl"            if USE_MUSL && !(arm || armeb)
+
+config MIPS64_ABI
+       depends on mips64 || mips64el
+       string
+       default "64" if MIPS64_ABI_N64
+       default "n32" if MIPS64_ABI_N32
+       default "32" if MIPS64_ABI_O32
+       default "64"